#
# Just another crappy game from jalski's game factory
#
# It's still unfinished...
# You can do what you like with it.
#
implement ApiAdventure;

include "sys.m";
   sys : Sys;

include "draw.m";
   draw : Draw;
   Context, Display, Point, Rect, Image, Screen, Font: import draw;

include "tk.m";
   tk: Tk;
   Toplevel : import tk;

include   "tkclient.m";
   tkclient : Tkclient;

include "keyboard.m";
   Up, Down, Right, Left: import Keyboard;

include "bufio.m";
   bufio : Bufio;
   Iobuf : import bufio;



ApiAdventure: module
{
   init:   fn(ctxt: ref Context, argv: list of string);
};



EMPTY, WALL, LADDER, GOAL, WALL2 : con iota;

TILEX : con 49;
TILEY : con 49;

ROWS : con 10;
COLUMNS : con 10;

LEFT : con Point(-1, 0);
RIGHT : con Point(1, 0);
UP : con Point(0, -1);
DOWN : con Point(0, 1);

FONTPATH : con "/fonts/lucida/unicode.18.font";
MSG : con "Level done!";
font : ref Font;

display : ref Display;
buffer : ref Image;
t: ref Toplevel;


tiles := array [5] of ref Image;
player_left, player_right, player_mask : ref Image;
rock_img : ref Image;
rock_mask : ref Image;


Player : adt
{
   pos : Point;
   img : ref Image;
   new : fn(x : int, y : int, img : ref Image) : ref Player;
   draw : fn(player : self ref Player);
   if_can_fall : fn(player : self ref Player);
};



Rock : adt
{
   pos : Point;
   new : fn(x : int, y : int) : ref Rock;   
   if_can_fall : fn(rock : self ref Rock);
};



Rocks : adt
{
   rocks : array of ref Rock;
   new : fn() : ref Rocks;
   add : fn(rocks : self ref Rocks, x : int, y : int);
   sort : fn(rocks : self ref Rocks);
   draw : fn(rocks : self ref Rocks);
   if_can_fall : fn(rocks : self ref Rocks);
   search_pos : fn(rocks : self ref Rocks, pos : Point) : ref Rock;
};



Level : adt
{
   map : array of array of int;
   rocks : ref Rocks;
   player : ref Player;
   new : fn() : ref Level;
   draw : fn(l : self ref Level);
   copy : fn(l : self ref Level) : ref Level;
};


level : ref Level;
levels : list of ref Level;
back_list : list of ref Level;
currentl : int;




gameui_cfg := array[] of {
   "frame .f",
   "button .f.left -bitmap small_color_left.bit -bd 0 -command {send cmdch prevl}",
   "button .f.right -bitmap small_color_right.bit -bd 0 -command {send cmdch nextl}",
   "button .f.reset -bitmap sadsmiley.bit -bd 0 -command {send cmdch reset}",
   "label .f.l -text {level: }",
   "label .f.level",
   "pack .f.left .f.right -side left",
   "pack .f.l -side left",
   "pack .f.level -side left",
   "pack .f.reset -side right",
   "pack .f -fill x",
};




init(ctxt: ref Context, nil: list of string)
{
   sys = load Sys Sys->PATH;
   draw = load Draw Draw->PATH;
   tk = load Tk Tk->PATH;
   tkclient = load Tkclient Tkclient->PATH;
   bufio = load Bufio Bufio->PATH;

   sys->pctl(Sys->NEWPGRP, nil);

   tkclient->init();

   if(ctxt == nil)
      ctxt = tkclient->makedrawcontext();

   display = ctxt.display;

   font = Font.open(display, FONTPATH);

   menubut : chan of string;
   (t, menubut) = tkclient->toplevel(ctxt, "", "Api's Adventure (with doggy style)", 0);

   cmdch := chan of string;
   tk->namechan(t, cmdch, "cmdch");

   for (i := 0; i < len gameui_cfg; i++)
      cmd(t, gameui_cfg[i]);

   tk->cmd(t, "update");
   tkclient->startinput(t, "ptr"::"kbd"::nil);
   tkclient->onscreen(t, nil);

   load_images();
   load_levels("./levels/levels.txt");
   currentl = 1;
   cmd(t, ".f.level configure -text " + string currentl);

   back_list = hd levels :: back_list;   
   level = (hd levels).copy();

   cmd(t, "panel .p -bd 3 -relief flat");
   cmd(t, "pack .p -fill both -expand 1");
   cmd(t, "update");
   tk->putimage(t, ".p", buffer, nil);

   level.draw();
   level.player.draw();
   level.rocks.draw();

   cmd(t, ".p dirty; update");


   for(;;) alt {
   s := <-t.ctxt.kbd =>
      processkbd(s);
   s := <-t.ctxt.ptr =>
      tk->pointer(t, *s);
   s := <-t.ctxt.ctl or
   s = <-t.wreq or
   s = <-menubut =>
      tkclient->wmctl(t, s);

   c := <- cmdch =>
      case c {
         "nextl" =>
            if (tl levels != nil)
            {
               back_list = hd levels :: back_list;
               levels = tl levels;
               level = (hd levels).copy();
               currentl ++;
               cmd(t, ".f.level configure -text " + string currentl);
               level.draw();
               level.player.draw();
               level.rocks.draw();
               cmd(t, ".p dirty; update");
            }

         "prevl" =>
            if (tl back_list != nil)
            {
               levels = hd back_list :: levels;
               back_list = tl back_list;      
               level = (hd back_list).copy();
               currentl --;
               cmd(t, ".f.level configure -text " + string currentl);
               level.draw();
               level.player.draw();
               level.rocks.draw();
               cmd(t, ".p dirty; update");
            }

         "reset" =>
            level = (hd levels).copy();
            level.draw();
            level.player.draw();
            level.rocks.draw();
            cmd(t, ".p dirty; update");

      }

   }

}




processkbd(kbd: int)
{
   case kbd {
      Up =>
         npos := level.player.pos.add(UP);

         if (npos.y >= ROWS || npos.y < 0)
            break;

         if (level.map[npos.x][npos.y] == LADDER || (level.map[level.player.pos.x][level.player.pos.y] == LADDER && level.map[npos.x][npos.y] == EMPTY))
         {
            draw_tile(level.map[level.player.pos.x][level.player.pos.y], level.player.pos);
            level.player.pos = npos;
            level.player.draw();
         }

      Down =>
         npos := level.player.pos.add(DOWN);

         if (npos.y >= ROWS || npos.y < 0)
            break;


         if (level.map[npos.x][npos.y] == LADDER)
         {
            draw_tile(level.map[level.player.pos.x][level.player.pos.y], level.player.pos);
            level.player.pos = npos;
            level.player.draw();
         }

         else if (level.map[npos.x][npos.y] == WALL2)
         {
            level.map[npos.x][npos.y] = EMPTY;
            draw_tile(level.map[npos.x][npos.y], npos);
            draw_tile(level.map[level.player.pos.x][level.player.pos.y], level.player.pos);
            level.player.pos = npos;
            level.player.if_can_fall();
            level.player.draw();
         }

      Left =>
         npos := level.player.pos.add(LEFT);

         if (npos.x >= COLUMNS || npos.x < 0)
            break;

         rock := level.rocks.search_pos(npos);
    
         if (rock != nil)
         {
            nrpos := rock.pos.add(LEFT);

            if (nrpos.x >= COLUMNS || nrpos.x < 0 || level.rocks.search_pos(nrpos) != nil )
               break;

            if (level.map[nrpos.x][nrpos.y] == EMPTY)
            {
               draw_tile(level.map[rock.pos.x][rock.pos.y], rock.pos);
               rock.pos = nrpos;               
            }
            else
               break;                  

         }

         if (level.map[npos.x][npos.y] != WALL)
         {
            if (level.map[npos.x][npos.y] == WALL2)
            {
               level.map[npos.x][npos.y] = EMPTY;
               draw_tile(level.map[npos.x][npos.y], npos);
            }

            draw_tile(level.map[level.player.pos.x][level.player.pos.y], level.player.pos);
            level.player.img = player_left;
            level.player.pos = npos;   
            level.player.if_can_fall();
            level.rocks.sort();
            level.rocks.if_can_fall();
            level.rocks.draw();
            level.player.draw();
         }

      Right =>
         npos := level.player.pos.add(RIGHT);

         if(npos.x >= COLUMNS || npos.x < 0)
            break;


         rock := level.rocks.search_pos(npos);
    
         if (rock != nil)
         {
            nrpos := rock.pos.add(RIGHT);

            if (nrpos.x >= COLUMNS || nrpos.x < 0 || level.rocks.search_pos(nrpos) != nil)
               break;            

            if (level.map[nrpos.x][nrpos.y] == EMPTY )
            {
               draw_tile(level.map[rock.pos.x][rock.pos.y], rock.pos);
               rock.pos = nrpos;
            }
            else
               break;                  

         }

         if (level.map[npos.x][npos.y] != WALL)
         {
            if (level.map[npos.x][npos.y] == WALL2)
            {
               level.map[npos.x][npos.y] = EMPTY;
               draw_tile(level.map[npos.x][npos.y], npos);
            }
 
            draw_tile(level.map[level.player.pos.x][level.player.pos.y], level.player.pos);
            level.player.img = player_right;
            level.player.pos = npos;
            level.player.if_can_fall();
            level.rocks.sort();
            level.rocks.if_can_fall();
            level.rocks.draw();
            level.player.draw();
            
         }


   }

   if (level.map[level.player.pos.x][level.player.pos.y] == GOAL)
   {
         buffer.text(Point(145,200), display.black, Point(0,0), font, MSG);
         cmd(t, ".p dirty; update");
         sys->sleep(200);

         if (tl levels != nil)
         {
            back_list = hd levels :: back_list;
            levels = tl levels;
            level = (hd levels).copy();
            currentl ++;
            cmd(t, ".f.level configure -text " + string currentl);
            level.draw();
            level.player.draw();
            level.rocks.draw();
            cmd(t, ".p dirty; update");
         }

   }


   cmd(t, ".p dirty; update");

}


Rock.new(x : int, y : int) : ref Rock
{
   rock := ref Rock(Point(x, y));
   return rock;
}


Rock.if_can_fall(rock : self ref Rock)
{
   pos := rock.pos;


   for(i := pos.y + 1; i < ROWS; i ++)
   {

      if (level.map[pos.x][i] != EMPTY || Point(pos.x, i).eq(level.player.pos))
               break;

      found := level.rocks.search_pos(Point(pos.x, i));
      if (found != nil)
         break;

      pos.y = i;

   }

   if (!rock.pos.eq(pos))
   {
      draw_tile(level.map[rock.pos.x][rock.pos.y], rock.pos);
      rock.pos = pos;
   }
          
}


Rocks.new() : ref Rocks
{
   rocks := ref Rocks;

   return rocks;
}



Rocks.add(rocks : self ref Rocks, x : int, y : int)
{
   i := len rocks.rocks;

   nrocks := array [i + 1] of ref Rock;

   (nrocks[0:],  nrocks[i], nrocks[i+1:]) = (rocks.rocks[0:i], Rock.new(x,y), rocks.rocks[i:]);

   rocks.rocks = nrocks;

}


Player.new(x : int, y : int, img : ref Image) : ref Player
{
   player := ref Player(Point(x,y), img);
   return player;
}


Player.if_can_fall(player : self ref Player)
{
   pos := player.pos;

   for(i := pos.y + 1; i < ROWS; i ++)
   {

      if (level.map[pos.x][i] != EMPTY || (level.rocks.search_pos(Point(pos.x, i)) != nil))
               break;

      
      pos.y = i;

   }

   if (!player.pos.eq(pos))
   {
      draw_tile(level.map[player.pos.x][player.pos.y], player.pos);
      player.pos = pos;
   }
          
}


Rocks.search_pos(rocks : self ref Rocks, pos : Point) : ref Rock
{
   count := len rocks.rocks;

   if (count < 1)
   {
      return nil;
   }

   for(i := 0; i < count; i ++)
   {
      if (rocks.rocks[i].pos.eq(pos))
      {
         return rocks.rocks[i];
      }
   }

   return nil;
}



Rocks.draw(rocks : self ref Rocks)
{
   count := len rocks.rocks;

   for(i := 0; i < count; i ++)
   {
      draw_sprite(rock_img, rock_mask, rocks.rocks[i].pos);
   }
}




Rocks.if_can_fall(rocks : self ref Rocks)
{
   count := len rocks.rocks;

   for(i := 0; i < count; i ++)
   {
      rocks.rocks[i].if_can_fall();
   }

}




Rocks.sort(rocks : self ref Rocks)
{
   count := len rocks.rocks;

   for(i := 1; i < count ; i ++) {
      v := rocks.rocks[i];
      j := i;
      while( ( j > 0 ) && ( rocks.rocks[j-1].pos.y < v.pos.y ))
      {
         rocks.rocks[j] = rocks.rocks[j - 1];
         j --;
      }
      rocks.rocks[j] = v;
   }
   
} 





load_images()
{

   tiles[0] = display.open("./data/empty.bit");
   if (tiles[0] == nil) {
      sys->fprint(sys->fildes(2), "Apis's Adventure: failed to allocate image\n");   
      exit;
   }

   tiles[1] = display.open("./data/wall.bit");
   if (tiles[1] == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   tiles[2] = display.open("./data/ladder.bit");
   if (tiles[2] == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   tiles[3] = display.open("./data/goal.bit");
   if (tiles[3] == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   tiles[4] = display.open("./data/wall2.bit");
   if (tiles[4] == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   rock_img = display.open("./data/rock.bit");
   if (rock_img == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   rock_mask = display.open("./data/rock_mask.bit");
   if (rock_mask == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }   

   player_right = display.open("./data/api.bit");
   if (player_right == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   player_left = display.open("./data/api.bit");
   if (player_left == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }

   player_mask = display.open("./data/api_mask.bit");
   if (player_left == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }


   r := Rect((0, 0), (COLUMNS * TILEX, ROWS * TILEY));
   buffer = display.newimage(r, t.image.chans, 0, Draw->Black);
   if (buffer == nil) {
      sys->fprint(sys->fildes(2), "Api's Adventure: failed to allocate image\n");   
      exit;
   }


}


draw_tile(tile : int, p : Point)
{
   p.x = p.x * tiles[tile].r.dx();
   p.y = p.y * tiles[tile].r.dy();

   buffer.draw(tiles[tile].r.addpt(p), tiles[tile], nil, Point(0, 0) ); 

}


Level.draw(l : self ref Level)
{
   
   for(row := 0; row < ROWS; row ++)
      for(column := 0; column < COLUMNS; column ++)
      {
         p := Point( column * TILEX, row * TILEY );
         buffer.draw(tiles[l.map[column][row] ].r.addpt(p), tiles[l.map[column][row] ], nil, Point(0, 0) );
      }    



}


Level.new() : ref Level
{
   l := ref Level;
   return l;
}


Level.copy(l: self ref Level): ref Level
{
   c := ref *l;
   c.map = array[COLUMNS] of { * => array[ROWS] of int };

   for(i := 0; i < COLUMNS; i++)
      c.map[i][0:] = l.map[i];


   c.rocks = c.rocks.new();

   for(i = 0; i < len l.rocks.rocks ; i++)
      c.rocks.add(l.rocks.rocks[i].pos.x, l.rocks.rocks[i].pos.y);

   c.player = ref *l.player;


   return c;
}


Player.draw(player : self ref Player)
{
   draw_sprite(player.img, player_mask, player.pos);
}


draw_sprite(image : ref Image, mask : ref Image, p : Point)
{
   p.x = p.x * image.r.dx();
   p.y = p.y * image.r.dy();

   buffer.draw(image.r.addpt(p), image, mask, Point(0, 0) ); 

}


load_levels(file: string)
{
   x := 0;
   y := 0;
   max := Point(0, 0);
   
   buf := bufio->open(file, Bufio->OREAD);
   if (buf == nil) {
      sys->fprint(sys->fildes(2), "cannot load %s: %r", file);
      exit;
   }

   map := array [COLUMNS] of { * => array [ROWS] of { * => EMPTY } };
   player := Player.new(0, 0, player_right);
   rocks := Rocks.new();

   line := 1;

   while((c := buf.getc()) >= 0)
   {
      case c {
      ';' =>
         while((c = buf.getc()) != '\n' && c != Bufio->EOF)
            ;

         line ++;

      '\n' =>
         max.y = ++ y;

         if(x != COLUMNS)
         {
            sys->fprint(sys->fildes(2), "Error on line: %d. Level map must have %d columns\n", line, COLUMNS);
            exit;
         }

         line ++;
         x = 0;


         if((c = buf.getc()) == '\n' || c == Bufio->EOF)
         {
            if (max.y != ROWS)
            {
               sys->fprint(sys->fildes(2), "Error on line: %d. Level map must have %d rows\n", line, ROWS);
               exit;
            }

            lev := Level.new();
            lev.map = map;
            lev.player = player;
            lev.rocks = rocks;
            levels = lev :: levels;

            map = array[COLUMNS] of { * => array[ROWS] of { * => EMPTY } };
            player = Player.new(0, 0, player_right);
            rocks = Rocks.new();

            max = Point(0, 0);
            y = 0;
            line ++;
         } 
         else
            buf.ungetc();

      '0' =>
         map[x][y] = EMPTY;
         x ++;

      '1' =>
         map[x][y] = WALL;
         x ++;

      '2' =>
         map[x][y] = LADDER;
         x ++;

      '3' =>
         map[x][y] = GOAL;
         x ++;

      '4' =>
         map[x][y] = WALL2;
         x ++;

      '@' =>
         player.pos = Point(x, y);
         x ++;

      'o' =>
         rocks.add(x, y);
         rocks.sort();
         x ++;

      * =>
         sys->fprint(sys->fildes(2), "impossible character: '%c' for level in line: %d\n", c, line);
         exit;
      }

      if (x > max.x)
         max.x = x;

      if (x >= COLUMNS || y >= ROWS)
      {
         if((c = buf.getc()) != '\n')
         {
            sys->fprint(sys->fildes(2), "Error on line: %d. Level map must be: %dx%d\n", line, COLUMNS, ROWS);
            exit;
         }
         buf.ungetc();
      }         

   }


}


cmd(win: ref Tk->Toplevel, s: string): string
{
   r := tk->cmd(win, s);
   if (len r > 0 && r[0] == '!') {
      sys->print("error executing '%s': %s\n", s, r[1:]);
   }
   return r;
}